diff --git a/philosophy/philosophy.pt-br.po b/philosophy/philosophy.pt-br.po
index c171e81..1d861ba 100644
--- a/philosophy/philosophy.pt-br.po
+++ b/philosophy/philosophy.pt-br.po
@@ -1,5 +1,5 @@
 # Brazilian Portuguese translation of http://www.gnu.org/philosophy/philosophy.html
-# Copyright (C) 2001, 2002, 2005, 2009 Free Software Foundation, Inc.
+# Copyright (C) 2001, 2002, 2005, 2009, 2017 Free Software Foundation, Inc.
 # This file is distributed under the same license as the gnu.org article.
 # Pedro Oliveira <bili@linux.fe.up.pt>, 2001.
 # Miguel Oliveira <pmike@esoterica.pt>, 2001.
@@ -7,21 +7,22 @@
 # Leandro Guimarães Faria Corcete Dutra <leandro.gfc.dutra@gmail.com>, 2009.
 # Rafael Beraldo <rberaldo@cabaladada.org>, 2012.
 # Rodrigo Macedo <rodrigomacedo@rmsolucoeseminformatica.com> 2012.
-# Rafael Ferreira <rafael.f.f1@gmail.com>, 2012.
 # Hudson Flávio Meneses Lacerda <hfmlacerda@yahoo.com.br>, 2013.
 # Dec 2014: remove wrong msgstr's, trivially update a few strings (T. Godefroy).
-#
+# Rafael Fontenelle <rafaelff@gnome.org>, 2012, 2013, 2017.
 msgid ""
 msgstr ""
 "Project-Id-Version: philosophy.html\n"
 "POT-Creation-Date: 2016-05-04 17:55+0000\n"
-"PO-Revision-Date: 2013-05-28 12:44-0300\n"
-"Last-Translator: Rafael Ferreira <rafael.f.f1@gmail.com>\n"
+"PO-Revision-Date: 2017-01-28 23:11-0200\n"
+"Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=2; plural=(n > 1);\n"
+"X-Generator: Virtaal 1.0.0-beta1\n"
 "Outdated-Since: 2013-06-18 05:25+0000\n"
 
 #. type: Content of: <title>
@@ -37,6 +38,8 @@ msgid ""
 "See <a href=\"http://audio-video.gnu.org/\">audio-video.gnu.org</a> for "
 "recordings of Richard Stallman's speeches."
 msgstr ""
+"Veja <a href=\"http://audio-video.gnu.org/\">audio-video.gnu.org</a> para "
+"gravações de discursos do Richard Stallman."
 
 #. type: Content of: <p>
 msgid ""
@@ -100,13 +103,16 @@ msgid ""
 "<a href=\"/philosophy/free-software-even-more-important.html\"> Why we must "
 "insist on free software</a>"
 msgstr ""
+"<a href=\"/philosophy/free-software-even-more-important.html\"> Porque nós "
+"devemos insistir no software livre</a>"
 
-# type: Content of: <ul><li>
 #. type: Content of: <ul><li>
 msgid ""
 "<a href=\"/philosophy/proprietary.html\"> Proprietary software is often "
 "malware</a>"
 msgstr ""
+"<a href=\"/philosophy/proprietary.html\"> Software proprietário "
+"frequentemente é malware</a>"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"/gnu/gnu.html\">History of GNU/Linux</a>"
@@ -123,7 +129,7 @@ msgid ""
 "Documentation</a>"
 msgstr ""
 "<a href=\"/philosophy/free-doc.html\">Por que o Software Livre Precisa de "
-"Documentação Livre</a> "
+"Documentação Livre</a>"
 
 #. type: Content of: <ul><li>
 msgid "<a href=\"/philosophy/selling.html\">Selling Free Software</a> is OK!"
@@ -141,7 +147,7 @@ msgid ""
 "<a href=\"/philosophy/right-to-read.html\">The Right to Read: A Dystopian "
 "Short Story</a> by <a href=\"http://www.stallman.org/\"> Richard Stallman</a>"
 msgstr ""
-"<a href=\"/philosophy/right-to-read.html\">O Direito à Leitura: Um Conto "
+"<a href=\"/philosophy/right-to-read.html\">O Direito de Ler: Um Conto "
 "Distópico</a> por <a href=\"http://www.stallman.org/\">Richard Stallman</a>"
 
 #. type: Content of: <ul><li>
@@ -150,23 +156,15 @@ msgid ""
 "\" misses the point of Free Software</a>"
 msgstr ""
 "<a href=\"/philosophy/open-source-misses-the-point.html\">Por que o “Código "
-"Aberto” não entende a importância do Software Livre</a>"
+"Aberto” não compartilha dos objetivos do Software Livre</a>"
 
 #. type: Content of: <ul><li>
-# | <a
-# | [-href=\"/philosophy/when_free_software_isnt_practically_better.html\">When-]
-# | {+href=\"/philosophy/when-free-software-isnt-practically-superior.html\">When+}
-# | Free Software Isn't (Practically) [-Better</a>-] {+Superior</a>+}
-#, fuzzy
-#| msgid ""
-#| "<a href=\"/philosophy/when_free_software_isnt_practically_better.html"
-#| "\">When Free Software Isn't (Practically) Better</a>"
 msgid ""
 "<a href=\"/philosophy/when-free-software-isnt-practically-superior.html"
 "\">When Free Software Isn't (Practically) Superior</a>"
 msgstr ""
-"<a href=\"/philosophy/when_free_software_isnt_practically_better.html"
-"\">Quando o Software Livre não é (na Prática) Melhor</a>"
+"<a href=\"/philosophy/when-free-software-isnt-practically-superior.html"
+"\">Quando o Software Livre não é (na Prática) Superior</a>"
 
 #. type: Content of: <ul><li>
 msgid ""
@@ -177,9 +175,8 @@ msgstr ""
 "governos podem usar para promover o software livre</a>"
 
 #. type: Content of: <ul><li>
-#, fuzzy
 msgid "<a href=\"/education/education.html\">Free software in education</a>"
-msgstr "<a href=\"/education/education.html\">Software Livre em Educação</a>"
+msgstr "<a href=\"/education/education.html\">Software livre na educação</a>"
 
 #.  please leave both these ID attributes here. ... 
 #.  ... we removed this as an H$ section as it was duplicating the  
@@ -193,16 +190,15 @@ msgid ""
 "Electronic Communications</a>."
 msgstr ""
 "<a id=\"TOCFreedomOrganizations\">Nós</a> <a id=\"FreedomOrganizations"
-"\">também</a> mantemos uma lista de <a href = \"/links/links."
+"\">também</a> mantemos uma lista de <a href=\"/links/links."
 "html#FreedomOrganizations\">Organizações que Trabalham pela Liberdade no "
-"Desenvolvimento de Informática e nas Comunicações Eletrônicas</a>."
+"Desenvolvimento da Computação e nas Comunicações Eletrônicas</a>."
 
 #. TRANSLATORS: Use space (SPC) as msgstr if you don't have notes.
 #. type: Content of: <div>
 msgid "*GNUN-SLOT: TRANSLATOR'S NOTES*"
 msgstr " "
 
-# type: Content of: <div><p>
 #. type: Content of: <div><div><p>
 msgid ""
 "Please send general FSF &amp; GNU inquiries to <a href=\"mailto:gnu@gnu.org"
@@ -244,20 +240,10 @@ msgstr ""
 "envio de traduções das páginas desse site."
 
 #. type: Content of: <div><p>
-# | Copyright &copy; [-2014, 2015-] {+2013, 2015, 2016+} Free Software
-# | Foundation, Inc.
-#, fuzzy
-#| msgid "Copyright &copy; 2014, 2015 Free Software Foundation, Inc."
 msgid "Copyright &copy; 2013, 2015, 2016 Free Software Foundation, Inc."
-msgstr "Copyright &copy; 2014, 2015 Free Software Foundation, Inc."
+msgstr "Copyright &copy; 2013, 2015, 2016 Free Software Foundation, Inc."
 
 #. type: Content of: <div><p>
-# || No change detected.  The change might only be in amounts of spaces.
-#, fuzzy
-#| msgid ""
-#| "This page is licensed under a <a rel=\"license\" href=\"http://"
-#| "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
-#| "NoDerivatives 4.0 International License</a>."
 msgid ""
 "This page is licensed under a <a rel=\"license\" href=\"http://"
 "creativecommons.org/licenses/by-nd/4.0/\">Creative Commons Attribution-"
@@ -278,7 +264,6 @@ msgstr ""
 "<a href=\"mailto:rberaldo@cabaladada.org\">&lt;rberaldo@cabaladada.org&gt;</"
 "a>, 2012"
 
-# type: Content of: <div><p>
 #.  timestamp start 
 #. type: Content of: <div><p>
 msgid "Updated:"