? make.check.log
? printf.patch
? pspp
? psppfiles.tar.bz2
Index: src/data/por-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/por-file-reader.c,v
retrieving revision 1.15
diff -u -p -r1.15 por-file-reader.c
--- src/data/por-file-reader.c	15 Dec 2006 00:16:02 -0000	1.15
+++ src/data/por-file-reader.c	7 Feb 2007 05:24:08 -0000
@@ -430,9 +430,9 @@ read_version_data (struct pfm_reader *r,
 
   /* Validate file. */
   if (strlen (date) != 8)
-    error (r, _("Bad date string length %d."), strlen (date));
+    error (r, _("Bad date string length %d."), (int) strlen (date));
   if (strlen (time) != 6)
-    error (r, _("Bad time string length %d."), strlen (time));
+    error (r, _("Bad time string length %d."), (int) strlen (time));
 
   /* Save file info. */
   if (info != NULL) 
Index: src/data/sys-file-reader.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/sys-file-reader.c,v
retrieving revision 1.31
diff -u -p -r1.31 sys-file-reader.c
--- src/data/sys-file-reader.c	16 Dec 2006 22:11:08 -0000	1.31
+++ src/data/sys-file-reader.c	7 Feb 2007 05:24:09 -0000
@@ -472,8 +472,8 @@ read_variable_record (struct sfm_reader 
 
       len = read_int32 (r);
       if (len >= sizeof label)
-        sys_error (r, _("Variable %s has label of invalid length %d."),
-                   name, len);
+        sys_error (r, _("Variable %s has label of invalid length %u."),
+                   name, (unsigned int) len);
       read_string (r, label, len + 1);
       var_set_label (var, label);
       
@@ -736,9 +736,9 @@ read_machine_int32_info (struct sfm_read
   int expected_integer_format;
 
   if (size != 4 || count != 8)
-    sys_error (r, _("Bad size (%d) or count (%d) field on record type 7, "
+    sys_error (r, _("Bad size (%u) or count (%u) field on record type 7, "
                     "subtype 3."),
-               size, count);
+               (unsigned int) size, (unsigned int) count);
 
   /* Check floating point format. */
   if (r->float_format == FLOAT_IEEE_DOUBLE_BE
@@ -781,8 +781,8 @@ read_machine_flt64_info (struct sfm_read
   double lowest = read_flt64 (r);
 
   if (size != 8 || count != 3)
-    sys_error (r, _("Bad size (%d) or count (%d) on extension 4."),
-               size, count);
+    sys_error (r, _("Bad size (%u) or count (%u) on extension 4."),
+               (unsigned int) size, (unsigned int) count);
 
   if (sysmis != SYSMIS)
     sys_warn (r, _("File specifies unexpected value %g as SYSMIS."), sysmis);
@@ -803,8 +803,8 @@ read_display_parameters (struct sfm_read
   int i;
 
   if (count % 3 || n_vars != dict_get_var_cnt (dict)) 
-    sys_error (r, _("Bad size (%d) or count (%d) on extension 11."),
-               size, count);
+    sys_error (r, _("Bad size (%u) or count (%u) on extension 11."),
+               (unsigned int) size, (unsigned int) count);
 
   for (i = 0; i < n_vars; ++i) 
     {
@@ -1003,8 +1003,8 @@ read_value_labels (struct sfm_reader *r,
   var_cnt = read_int32 (r);
   if (var_cnt < 1 || var_cnt > dict_get_var_cnt (dict))
     sys_error (r, _("Number of variables associated with a value label (%d) "
-                    "is not between 1 and the number of variables (%d)."),
-               var_cnt, dict_get_var_cnt (dict));
+                    "is not between 1 and the number of variables (%u)."),
+               var_cnt, (unsigned int) dict_get_var_cnt (dict));
 
   /* Read the list of variables. */
   var = pool_nalloc (subpool, var_cnt, sizeof *var);
Index: src/language/data-io/file-handle.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/file-handle.q,v
retrieving revision 1.12
diff -u -p -r1.12 file-handle.q
--- src/language/data-io/file-handle.q	2 Feb 2007 00:57:32 -0000	1.12
+++ src/language/data-io/file-handle.q	7 Feb 2007 05:24:09 -0000
@@ -98,12 +98,12 @@ cmd_file_handle (struct lexer *lexer, st
       if (cmd.n_lrecl[0] == NOT_LONG)
         msg (SE, _("Fixed-length records were specified on /RECFORM, but "
                    "record length was not specified on /LRECL.  "
-                   "Assuming %d-character records."),
-             properties.record_width);
+                   "Assuming %u-character records."),
+             (unsigned int) properties.record_width);
       else if (cmd.n_lrecl[0] < 1)
         msg (SE, _("Record length (%ld) must be at least one byte.  "
-                   "Assuming %d-character records."),
-             cmd.n_lrecl[0], properties.record_width);
+                   "Assuming %u-character records."),
+             cmd.n_lrecl[0], (unsigned int) properties.record_width);
       else
         properties.record_width = cmd.n_lrecl[0];
       break;
Index: src/language/data-io/placement-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/placement-parser.c,v
retrieving revision 1.4
diff -u -p -r1.4 placement-parser.c
--- src/language/data-io/placement-parser.c	15 Dec 2006 00:16:02 -0000	1.4
+++ src/language/data-io/placement-parser.c	7 Feb 2007 05:24:10 -0000
@@ -117,8 +117,8 @@ fixed_parse_columns (struct lexer *lexer
   if ((lc - fc + 1) % var_cnt)
     {
       msg (SE, _("The %d columns %d-%d "
-		 "can't be evenly divided into %d fields."),
-	   lc - fc + 1, fc, lc, var_cnt);
+		 "can't be evenly divided into %u fields."),
+	   lc - fc + 1, fc, lc, (unsigned int) var_cnt);
       return false;
     }
 
Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.23
diff -u -p -r1.23 print.c
--- src/language/data-io/print.c	15 Dec 2006 00:16:02 -0000	1.23
+++ src/language/data-io/print.c	7 Feb 2007 05:24:10 -0000
@@ -257,9 +257,9 @@ parse_specs (struct lexer *lexer, struct
     }
 
   if (trns->record_cnt != 0 && trns->record_cnt != record)
-    msg (SW, _("Output calls for %d records but %d specified on RECORDS "
+    msg (SW, _("Output calls for %d records but %u specified on RECORDS "
                "subcommand."),
-         record, trns->record_cnt);
+         record, (unsigned int) trns->record_cnt);
   trns->record_cnt = record;
 
   return true;
Index: src/language/dictionary/modify-variables.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/modify-variables.c,v
retrieving revision 1.15
diff -u -p -r1.15 modify-variables.c
--- src/language/dictionary/modify-variables.c	15 Dec 2006 00:16:02 -0000	1.15
+++ src/language/dictionary/modify-variables.c	7 Feb 2007 05:24:10 -0000
@@ -210,7 +210,8 @@ cmd_modify_vars (struct lexer *lexer, st
 		{
 		  msg (SE, _("Differing number of variables in old name list "
 		       "(%d) and in new name list (%d)."),
-		       vm.rename_cnt - prev_nv_2, prev_nv_1 - prev_nv_2);
+		       (int) (vm.rename_cnt - prev_nv_2),
+                       (int) (prev_nv_1 - prev_nv_2));
 		  for (i = 0; i < prev_nv_1; i++)
 		    free (vm.new_names[i]);
 		  free (vm.new_names);
Index: src/language/dictionary/rename-variables.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/rename-variables.c,v
retrieving revision 1.9
diff -u -p -r1.9 rename-variables.c
--- src/language/dictionary/rename-variables.c	15 Dec 2006 00:16:02 -0000	1.9
+++ src/language/dictionary/rename-variables.c	7 Feb 2007 05:24:10 -0000
@@ -75,9 +75,9 @@ cmd_rename_variables (struct lexer *lexe
           size_t i;
 
 	  msg (SE, _("Differing number of variables in old name list "
-                     "(%u) and in new name list (%u)."),
-	       (unsigned) rename_cnt - prev_nv_2,
-               (unsigned) prev_nv_1 - prev_nv_2);
+                     "(%d) and in new name list (%d)."),
+	       (int) (rename_cnt - prev_nv_2),
+               (int) (prev_nv_1 - prev_nv_2));
 	  for (i = 0; i < prev_nv_1; i++)
 	    free (rename_new_names[i]);
 	  free (rename_new_names);
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.20
diff -u -p -r1.20 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	15 Dec 2006 00:16:02 -0000	1.20
+++ src/language/dictionary/sys-file-info.c	7 Feb 2007 05:24:11 -0000
@@ -132,8 +132,8 @@ cmd_sysfile_info (struct lexer *lexer, s
             : info.float_format == FLOAT_Z_LONG ? _("IBM 390 Hex Long.")
             : _("Unknown."));
   tab_text (t, 0, 5, TAB_LEFT, _("Variables:"));
-  tab_text (t, 1, 5, TAB_LEFT | TAT_PRINTF, "%d",
-		dict_get_var_cnt (d));
+  tab_text (t, 1, 5, TAB_LEFT | TAT_PRINTF, "%u",
+            (unsigned int) dict_get_var_cnt (d));
   tab_text (t, 0, 6, TAB_LEFT, _("Cases:"));
   tab_text (t, 1, 6, TAB_LEFT | TAT_PRINTF,
 		info.case_cnt == -1 ? _("Unknown") : "%d", info.case_cnt);
Index: src/language/lexer/lexer.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/lexer.c,v
retrieving revision 1.18
diff -u -p -r1.18 lexer.c
--- src/language/lexer/lexer.c	15 Dec 2006 00:16:02 -0000	1.18
+++ src/language/lexer/lexer.c	7 Feb 2007 05:24:12 -0000
@@ -1047,7 +1047,7 @@ convert_numeric_string_to_char_string (s
   if (ds_length (&lexer->tokstr) % chars_per_byte)
     msg (SE, _("String of %s digits has %d characters, which is not a "
 	       "multiple of %d."),
-	 base_name, ds_length (&lexer->tokstr), chars_per_byte);
+	 base_name, (int) ds_length (&lexer->tokstr), chars_per_byte);
 
   p = ds_cstr (&lexer->tokstr);
   for (i = 0; i < byte_cnt; i++)
@@ -1184,7 +1184,7 @@ finish:
   if (ds_length (&lexer->tokstr) > 255)
     {
       msg (SE, _("String exceeds 255 characters in length (%d characters)."),
-	   ds_length (&lexer->tokstr));
+	   (int) ds_length (&lexer->tokstr));
       ds_truncate (&lexer->tokstr, 255);
     }
       
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.29
diff -u -p -r1.29 aggregate.c
--- src/language/stats/aggregate.c	10 Jan 2007 03:18:02 -0000	1.29
+++ src/language/stats/aggregate.c	7 Feb 2007 05:24:12 -0000
@@ -520,8 +520,8 @@ parse_aggregate_functions (struct lexer 
 		  }
                 else
                   {
-		    msg (SE, _("Missing argument %d to %s."), i + 1,
-                         function->name);
+		    msg (SE, _("Missing argument %d to %s."),
+                         (int) i + 1, function->name);
 		    goto error;
 		  }
 	    
Index: src/language/stats/descriptives.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/descriptives.c,v
retrieving revision 1.21
diff -u -p -r1.21 descriptives.c
--- src/language/stats/descriptives.c	23 Dec 2006 06:11:33 -0000	1.21
+++ src/language/stats/descriptives.c	7 Feb 2007 05:24:13 -0000
@@ -175,7 +175,7 @@ static bool try_name (const struct dicti
 		      struct dsc_proc *dsc, const char *name);
 static bool generate_z_varname (const struct dictionary *dict, 
 				struct dsc_proc *dsc, char *z_name,
-				const char *name, size_t *z_cnt);
+				const char *name, int *z_cnt);
 static void dump_z_table (struct dsc_proc *);
 static void setup_z_trns (struct dsc_proc *, struct dataset *);
 
@@ -196,7 +196,7 @@ cmd_descriptives (struct lexer *lexer, s
   struct variable **vars = NULL;
   size_t var_cnt = 0;
   int save_z_scores = 0;
-  size_t z_cnt = 0;
+  int z_cnt = 0;
   size_t i;
   bool ok;
 
@@ -370,7 +370,7 @@ cmd_descriptives (struct lexer *lexer, s
     {
       if (save_z_scores) 
         {
-          size_t gen_cnt = 0;
+          int gen_cnt = 0;
 
           for (i = 0; i < dsc->var_cnt; i++)
             if (dsc->vars[i].z_name[0] == 0) 
@@ -491,7 +491,7 @@ try_name (const struct dictionary *dict,
    copies the new name into Z_NAME.  On failure, returns false. */
 static bool
 generate_z_varname (const struct dictionary *dict, struct dsc_proc *dsc, char *z_name,
-                    const char *var_name, size_t *z_cnt)
+                    const char *var_name, int *z_cnt)
 {
   char name[LONG_NAME_LEN + 1];
 
Index: src/language/stats/npar.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/npar.q,v
retrieving revision 1.2
diff -u -p -r1.2 npar.q
--- src/language/stats/npar.q	23 Dec 2006 06:11:33 -0000	1.2
+++ src/language/stats/npar.q	7 Feb 2007 05:24:13 -0000
@@ -421,7 +421,7 @@ parse_two_sample_related_test (struct le
 	  if ( n_vlist1 != n_vlist2) 
 	    msg (SE, _("PAIRED was specified but the number of variables "
 		       "preceding WITH (%d) did not match the number "
-		       "following (%d)."), n_vlist1, n_vlist2);
+		       "following (%d)."), (int) n_vlist1, (int) n_vlist2);
 
 	  test_parameters->n_pairs = n_vlist1 ;
 	}
Index: src/language/stats/oneway.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.20
diff -u -p -r1.20 oneway.q
--- src/language/stats/oneway.q	16 Jan 2007 15:30:28 -0000	1.20
+++ src/language/stats/oneway.q	7 Feb 2007 05:24:14 -0000
@@ -175,7 +175,8 @@ output_oneway(void)
 	sum += subc_list_double_at(&cmd.dl_contrast[i],j);
 
       if ( sum != 0.0 ) 
-	msg(SW,_("Coefficients for contrast %d do not total zero"),i + 1);
+	msg(SW,_("Coefficients for contrast %d do not total zero"),
+            (int) i + 1);
     }
 
   if ( stat_tables & STAT_DESC ) 
Index: src/language/stats/regression.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.44
diff -u -p -r1.44 regression.q
--- src/language/stats/regression.q	4 Feb 2007 16:38:26 -0000	1.44
+++ src/language/stats/regression.q	7 Feb 2007 05:24:16 -0000
@@ -765,8 +765,8 @@ reg_print_categorical_encoding (FILE * f
 
   for (i = 0; i < n_vars; i++)
     {
-      size_t n_categories = cat_get_n_categories (varlist[i]);
-      size_t j;
+      int n_categories = cat_get_n_categories (varlist[i]);
+      int j;
       
       fprintf (fp, "%s.name = \"%s\";\n\t",
                var_get_name (varlist[i]),
Index: src/language/stats/t-test.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/t-test.q,v
retrieving revision 1.19
diff -u -p -r1.19 t-test.q
--- src/language/stats/t-test.q	23 Dec 2006 06:11:33 -0000	1.19
+++ src/language/stats/t-test.q	7 Feb 2007 05:24:16 -0000
@@ -485,7 +485,7 @@ tts_custom_pairs (struct lexer *lexer, s
 	  msg (SE, _("PAIRED was specified but the number of variables "
 		     "preceding WITH (%d) did not match the number "
 		     "following (%d)."),
-	       n_before_WITH, n_after_WITH );
+	       (int) n_before_WITH, (int) n_after_WITH );
 	  return 0;
 	}
       n_pairs_local = n_before_WITH;
Index: src/language/tests/moments-test.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/tests/moments-test.c,v
retrieving revision 1.8
diff -u -p -r1.8 moments-test.c
--- src/language/tests/moments-test.c	15 Dec 2006 00:16:03 -0000	1.8
+++ src/language/tests/moments-test.c	7 Feb 2007 05:24:16 -0000
@@ -125,7 +125,7 @@ cmd_debug_moments (struct lexer *lexer, 
   fprintf (stderr, "W=%.3f", weight);
   for (i = 0; i < 4; i++) 
     {
-      fprintf (stderr, " M%d=", i + 1);
+      fprintf (stderr, " M%d=", (int) i + 1);
       if (M[i] == SYSMIS)
         fprintf (stderr, "sysmis");
       else if (fabs (M[i]) <= 0.0005)
Index: src/math/sort.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/sort.c,v
retrieving revision 1.22
diff -u -p -r1.22 sort.c
--- src/math/sort.c	22 Dec 2006 11:12:15 -0000	1.22
+++ src/math/sort.c	7 Feb 2007 05:24:16 -0000
@@ -467,8 +467,9 @@ allocate_cases (struct initial_run_state
     {
       msg (SE, _("Out of memory.  Could not allocate room for minimum of %d "
 		 "cases of %d bytes each.  (PSPP workspace is currently "
-		 "restricted to a maximum of %d KB.)"),
-	   min_buffers, approx_case_cost, get_workspace() / 1024);
+		 "restricted to a maximum of %lu KB.)"),
+	   min_buffers, approx_case_cost,
+           (unsigned long int) (get_workspace() / 1024));
       return 0;
     }
   return 1;
Index: src/output/html.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/output/html.c,v
retrieving revision 1.16
diff -u -p -r1.16 html.c
--- src/output/html.c	15 Dec 2006 00:16:03 -0000	1.16
+++ src/output/html.c	7 Feb 2007 05:24:16 -0000
@@ -375,7 +375,7 @@ html_initialise_chart (struct outp_drive
   number_pos = strchr (x->chart_file_name, '#') - x->chart_file_name;
   ch->file_name = xasprintf ("%.*s%d%s",
                              number_pos, x->chart_file_name,
-                             x->chart_cnt,
+                             (int) x->chart_cnt,
                              x->chart_file_name + number_pos + 1);
   fp = fopen (ch->file_name, "wb");
   if (fp == NULL) 